﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win;
using Infragistics.Win.UltraWinEditors;
using Infragistics.Win.UltraWinGrid;
using System.Globalization;
using System.Diagnostics;

namespace SortTest
{
    #region frmMain class
    public partial class frmMain : Form
    {
        private DataTable table = null;

        public frmMain()
        {
            InitializeComponent();

            this.grid.Dock = DockStyle.Fill;
            this.grid.DataSource = this.Data;
            this.grid.DisplayLayout.Bands[0].Columns["Foo"].SortIndicator = SortIndicator.Ascending;

        }

        private DataTable Data
        {
            get
            {
                if ( this.table == null )
                {
                    this.table = new DataTable();

                    //  Add columns
                    this.table.Columns.Add( "Foo", typeof(string) );

                    //  Add rows
                    this.table.Rows.Add( new object[]{ "28000" } );
                    this.table.Rows.Add( new object[]{ "1" } );
                    this.table.Rows.Add( new object[]{ "8923" } );
                    this.table.Rows.Add( new object[]{ "8921" } );
                    this.table.Rows.Add( new object[]{ "z3423" } );
                    this.table.Rows.Add( new object[]{ "8931" } );

                }

                return this.table;
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            this.grid.DisplayLayout.Bands[0].Columns["Foo"].SortComparer = new InvoiceNumberSort();
        }
    }
    #endregion frmMain class

    #region InvoiceNumberSort class
    public class InvoiceNumberSort : System.Collections.IComparer
    {	

        public int Compare(object o1, object o2)
        {			
            UltraGridCell cell1 = (UltraGridCell)o1;
            UltraGridCell cell2 = (UltraGridCell)o2; 			
            string strValue1 = cell1.Value as string;
            string strValue2 = cell2.Value as string;
            int nValue1 = 0;			
            int nValue2 = 0; 			
            bool value1IsInt = int.TryParse(strValue1, out nValue1);			
            bool value2IsInt = int.TryParse(strValue2, out nValue2); 			
            int comparison = 0; 			
            
            if (value1IsInt && value2IsInt)			
            {				
                if (nValue1 > nValue2)				
                {					
                    comparison = 1;				
                }
                else if (nValue1 < nValue2)				
                {					
                    comparison = -1;				
                }				
                else				
                {					
                    comparison = 0;				
                } 			
            }			
            else			
            {				
                comparison = string.Compare(strValue1, strValue2, true);
            }						
            
            return comparison;		
        }	
    }
    #endregion InvoiceNumberSort class
}
